Index: admin/js/_plugins.js
===================================================================
--- admin/js/_plugins.js	(revision 0)
+++ admin/js/_plugins.js	(revision 2222)
@@ -1,6 +1,158 @@
+dotclear.moduleExpander = function(line) {
+        var td = line.firstChild;
+        
+        var img = document.createElement('img');
+        img.src = dotclear.img_plus_src;
+        img.alt = dotclear.img_plus_alt;
+        img.className = 'expand';
+        $(img).css('cursor','pointer');
+        img.line = line;
+        img.onclick = function() { dotclear.viewModuleContent(this,this.line); };
+        
+        td.insertBefore(img,td.firstChild);
+};
+
+dotclear.modulesExpander = function(line,lines) {
+        var td = line.firstChild;
+
+        var img = document.createElement('img');
+        img.src = dotclear.img_plus_src;
+        img.alt = dotclear.img_plus_alt;
+        img.className = 'expand';
+        $(img).css('cursor','pointer');
+        img.lines = lines;
+        img.onclick = function() { dotclear.viewModulesContent(this,this.lines); };
+
+        td.insertBefore(img,td.firstChild);
+};
+
+dotclear.viewModulesContent = function(img,lines) {
+        
+        action = 'toggle';
+
+        if (img.alt == dotclear.img_plus_alt) {
+                img.src = dotclear.img_minus_src;
+                img.alt = dotclear.img_minus_alt;
+                action = 'open';
+        } else {
+                img.src = dotclear.img_plus_src;
+                img.alt = dotclear.img_plus_alt;
+                action = 'close';
+        }
+        
+        lines.each(function() {
+                var td = this.firstChild;
+                dotclear.viewModuleContent(td.firstChild,td.firstChild.line,action);
+        });
+};
+
+dotclear.viewModuleContent = function(img,line,action) {
+
+        var action = action || 'toggle';
+		var cols = $('td',$(line)).length
+        var sp = line.id.split('_m_');
+		var listId=sp[0];
+		var moduleId= sp[1];
+
+        var tr = document.getElementById('pe'+moduleId);
+        
+		if ( !tr && ( action == 'toggle' || action == 'open' ) ) {
+                tr = document.createElement('tr');
+                tr.id = 'pe'+moduleId;
+
+                var td = document.createElement('td');
+                td.colSpan = cols;
+                td.className = 'expand';
+                tr.appendChild(td);
+                
+                img.src = dotclear.img_minus_src;
+                img.alt = dotclear.img_minus_alt;
+                
+                // Get post content
+                $.get('services.php',{f:'getModuleById', id: moduleId, list: listId},function(data) {
+                        var rsp = $(data).children('rsp')[0];
+                        
+                        if (rsp.attributes[0].value == 'ok') {
+                                var author = $(rsp).find('author').text();
+                                var details = $(rsp).find('details').text();
+                                var support = $(rsp).find('support').text();
+								var box = document.createElement('div');
+                                var bloc = document.createElement('ul');
+                                bloc.className = "mod-more";
+                                
+                                if (author) {
+                                        $(bloc).append($('<li class="module-author">'+dotclear.msg.module_author+' '+author+'</li>'));
+                                }
+                                if (details) {
+                                        var dd = '';
+                                        dd += '<a class="module-details" href="'+details+'">'+dotclear.msg.module_details+'</a>';
+                                        if (support) {
+                                                dd += ' - ';
+                                                dd += '<a class="module-support" href="'+support+'">'+dotclear.msg.module_support+'</a>';
+                                        }
+                                        $(bloc).append($('<li>'+dotclear.msg.module_help+' '+dd+'</li>'));
+                                }
+
+                                $(td).append($(box).addClass('two-boxes').append(bloc));
+                                
+                                var section = $(rsp).find('section').text();
+                                var tags = $(rsp).find('tags').text();
+                                
+								var boxb = document.createElement('div');
+                                var blocb = document.createElement('ul');
+                                blocb.className = "mod-more";
+                                
+                                if (section) {
+                                        $(blocb).append($('<li class="module-section">'+dotclear.msg.module_section+' '+section+'</li>'));
+                                }
+                                if (tags) {
+                                        $(blocb).append($('<li class="module-tags">'+dotclear.msg.module_tags+' '+tags+'</li>'));
+                                }
+                                $(td).append($(boxb).addClass('two-boxes').append(blocb));
+                        } else {
+                                alert($(rsp).find('message').text());
+                        }
+                });
+                
+                $(line).addClass('expand');
+                line.parentNode.insertBefore(tr,line.nextSibling);
+        }
+        else if (tr && tr.style.display == 'none' && ( action == 'toggle' || action == 'open' ) )
+        {
+                $(tr).css('display', 'table-row');
+                $(line).addClass('expand');
+                img.src = dotclear.img_minus_src;
+                img.alt = dotclear.img_minus_alt;
+        }
+        else if (tr && tr.style.display != 'none' && ( action == 'toggle' || action == 'close' ) )
+        {
+                $(tr).css('display', 'none');
+                $(line).removeClass('expand');
+                img.src = dotclear.img_plus_src;
+                img.alt = dotclear.img_plus_alt;
+        }
+        
+        parentTable = $(line).parents('table');
+        if( parentTable.find('tr.expand').length == parentTable.find('tr.line').length ) {
+                img = parentTable.find('tr:not(.line) th:first img');
+                img.attr('src',dotclear.img_minus_src);
+                img.attr('alt',dotclear.img_minus_alt);
+        }
+        
+        if( parentTable.find('tr.expand').length == 0 ) {
+                img = parentTable.find('tr:not(.line) th:first img');
+                img.attr('src',dotclear.img_plus_src);
+                img.attr('alt',dotclear.img_plus_alt);
+        }
+        
+};
+
+
 $(function() {
-	$('table.plugins form input[type=submit][name=delete]').click(function() {
-		var p_name = $('input[name=plugin_id]',$(this).parent()).val();
-		return window.confirm(dotclear.msg.confirm_delete_plugin.replace('%s',p_name));
-	});
+        $('table.modules.expandable tr:not(.line)').each(function() {
+                dotclear.modulesExpander(this,$('table.modules.expandable tr.line'));
+        });
+        $('table.modules.expandable tr.line').each(function() {
+                dotclear.moduleExpander(this);
+        });
 });
Index: admin/js/common.js
===================================================================
--- admin/js/common.js	(revision 2248)
+++ admin/js/common.js	(revision 2225)
@@ -407,12 +407,6 @@
 
 	// manage outgoing links
-	$('a').filter(function() {
-		return ((this.hostname && this.hostname!=location.hostname)
-			|| $(this).hasClass('outgoing'));
-	}).each(function() {
-		$(this).prop('title',$(this).prop('title')+' ('+dotclear.msg.new_window+')');
-		if (!$(this).hasClass('outgoing')) {
-			$(this).append(' <img src="images/outgoing-blue.png" alt=""/>');
-		}
+	$('.outgoing').each(function() {
+		$(this).prop('title',$(this).attr('title')+' ('+dotclear.msg.new_window+')');
 	}).click(function(e) {
 		e.preventDefault();
Index: admin/langs.php
===================================================================
--- admin/langs.php	(revision 2256)
+++ admin/langs.php	(revision 2166)
@@ -49,6 +49,5 @@
 		}
 		
-		dcPage::addSuccessNotice(__('Language has been successfully deleted.'));
-		http::redirect('langs.php');
+		http::redirect('langs.php?removed=1');
 	}
 	catch (Exception $e)
@@ -88,10 +87,5 @@
 		
 		@unlink($dest);
-		if ($ret_code == 2) {
-			dcPage::addSuccessNotice( __('Language has been successfully upgraded'));
-		} else {
-			dcPage::addSuccessNotice($__('Language has been successfully installed.'));
-		}
-		http::redirect('langs.php');
+		http::redirect('langs.php?added='.$ret_code);
 	}
 	catch (Exception $e)
@@ -124,10 +118,5 @@
 		
 		@unlink($dest);
-		if ($ret_code == 2) {
-			dcPage::addSuccessNotice( __('Language has been successfully upgraded'));
-		} else {
-			dcPage::addSuccessNotice($__('Language has been successfully installed.'));
-		}
-		http::redirect('langs.php');
+		http::redirect('langs.php?added='.$ret_code);
 	}
 	catch (Exception $e)
Index: admin/media.php
===================================================================
--- admin/media.php	(revision 2256)
+++ admin/media.php	(revision 2228)
@@ -129,9 +129,5 @@
 	try {
 		$core->media->makeDir($_POST['newdir']);
-		dcPage::addSuccessNotice(sprintf(
-			__('Directory "%s" has been successfully created.'),
-			html::escapeHTML($_POST['newdir']))
-		);
-		http::redirect($page_url.'&d='.rawurlencode($d));
+		http::redirect($page_url.'&d='.rawurlencode($d).'&mkdok=1');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -177,7 +173,5 @@
 
 			$core->media->uploadFile($upfile['tmp_name'], $upfile['name'], $f_title, $f_private);
-
-			dcPage::addSuccessNotice(__('Files have been successfully uploaded.'));
-			http::redirect($page_url.'&d='.rawurlencode($d));
+			http::redirect($page_url.'&d='.rawurlencode($d).'&upok=1');
 		} catch (Exception $e) {
 			$core->error->add($e->getMessage());
@@ -213,7 +207,5 @@
 	try {
 		$core->media->removeItem($_POST['remove']);
-
-		dcPage::addSuccessNotice(__('File has been successfully removed.'));
-		http::redirect($page_url.'&d='.rawurlencode($d));
+		http::redirect($page_url.'&d='.rawurlencode($d).'&rmfok=1');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -226,10 +218,5 @@
 	try {
 		$core->media->rebuild($d);
-
-		dcPage::success(sprintf(
-			__('Directory "%s" has been successfully rebuilt.'),
-			html::escapeHTML($d))
-		);
-		http::redirect($page_url.'&d='.rawurlencode($d));
+		http::redirect($page_url.'&d='.rawurlencode($d).'&rebuildok=1');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
Index: admin/media_item.php
===================================================================
--- admin/media_item.php	(revision 2256)
+++ admin/media_item.php	(revision 2211)
@@ -81,7 +81,5 @@
 		files::uploadStatus($_FILES['upfile']);
 		$core->media->uploadFile($_FILES['upfile']['tmp_name'],$file->basename,null,false,true);
-
-		dcPage::addSuccessNotice(__('File has been successfully updated.'));
-		http::redirect($page_url.'&id='.$id);
+		http::redirect($page_url.'&id='.$id.'&fupl=1');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -110,7 +108,5 @@
 	try {
 		$core->media->updateFile($file,$newFile);
-
-		dcPage::addSuccessNotice(__('File has been successfully updated.'));
-		http::redirect($page_url.'&id='.$id.'&tab=media-details-tab');
+		http::redirect($page_url.'&id='.$id.'&fupd=1&tab=media-details-tab');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -124,7 +120,5 @@
 		$foo = null;
 		$core->media->mediaFireRecreateEvent($file);
-		
-		dcPage::addSuccessNotice(__('Thumbnails have been successfully updated.'));
-		http::redirect($page_url.'&id='.$id.'&tab=media-details-tab');
+		http::redirect($page_url.'&id='.$id.'&thumbupd=1&tab=media-details-tab');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -137,7 +131,5 @@
 	try {
 		$unzip_dir = $core->media->inflateZipFile($file,$_POST['inflate_mode'] == 'new');
-		
-		dcPage::addSuccessNotice(__('Zip file has been successfully extracted.'));
-		http::redirect($media_page_url.'&d='.$unzip_dir);
+		http::redirect($media_page_url.'&d='.$unzip_dir.'&unzipok=1');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -162,7 +154,5 @@
 		$core->blog->settings->system->put('media_img_default_link',($_POST['pref_insertion'] == 'link'));
 	}
-	
-	dcPage::addSuccessNotice(__('Default media insertion settings have been successfully updated.'));
-	http::redirect($page_url.'&id='.$id);
+	http::redirect($page_url.'&id='.$id.'&blogprefupd=1');
 }
 
Index: admin/plugins.php
===================================================================
--- admin/plugins.php	(revision 2256)
+++ admin/plugins.php	(revision 2241)
@@ -13,188 +13,100 @@
 require dirname(__FILE__).'/../inc/admin/prepend.php';
 
-dcPage::checkSuper();
-
-$default_tab = !empty($_REQUEST['tab']) ? html::escapeHTML($_REQUEST['tab']) : 'plugins';
-
-$p_paths = explode(PATH_SEPARATOR, DC_PLUGINS_ROOT);
-$p_path = array_pop($p_paths);
-unset($p_paths);
-
-$is_writable = false;
-if (is_dir($p_path) && is_writeable($p_path)) {
-	$is_writable = true;
-	$p_path_pat = preg_quote($p_path,'!');
-}
-
-$plugin_id = !empty($_POST['plugin_id']) ? $_POST['plugin_id'] : null;
-
-if ($is_writable)
-{
-	# Delete plugin
-	if ($plugin_id && !empty($_POST['delete']))
-	{
-		try
-		{
-			if (empty($_POST['deactivated']))
-			{
-				if (!$core->plugins->moduleExists($plugin_id)) {
-					throw new Exception(__('No such plugin.'));
-				}
-				
-				$plugin = $core->plugins->getModules($plugin_id);
-				$plugin['id'] = $plugin_id;
-				
-				if (!preg_match('!^'.$p_path_pat.'!', $plugin['root'])) {
-					throw new Exception(__('You don\'t have permissions to delete this plugin.'));
-				}
-				
-				# --BEHAVIOR-- pluginBeforeDelete
-				$core->callBehavior('pluginsBeforeDelete', $plugin);
-				
-				$core->plugins->deleteModule($plugin_id);
-				
-				# --BEHAVIOR-- pluginAfterDelete
-				$core->callBehavior('pluginsAfterDelete', $plugin);
-			}
-			else
-			{
-				$core->plugins->deleteModule($plugin_id,true);
-			}
-
-			dcPage::addSuccessNotice(__('Plugin has been successfully deleted.'));
-			http::redirect('plugins.php');
-		}
-		catch (Exception $e)
-		{
-			$core->error->add($e->getMessage());
-		}
-	}
-	# Deactivate plugin
-	elseif ($plugin_id && !empty($_POST['deactivate']))
-	{
-		try
-		{
-			if (!$core->plugins->moduleExists($plugin_id)) {
-				throw new Exception(__('No such plugin.'));
-			}
-			
-			$plugin = $core->plugins->getModules($plugin_id);
-			$plugin['id'] = $plugin_id;
-			
-			if (!$plugin['root_writable']) {
-				throw new Exception(__('You don\'t have permissions to deactivate this plugin.'));
-			}
-			
-			# --BEHAVIOR-- pluginBeforeDeactivate
-			$core->callBehavior('pluginsBeforeDeactivate', $plugin);
-				
-			$core->plugins->deactivateModule($plugin_id);
-
-			# --BEHAVIOR-- pluginAfterDeactivate
-			$core->callBehavior('pluginsAfterDeactivate', $plugin);
-				
-			http::redirect('plugins.php');
-		}
-		catch (Exception $e)
-		{
-			$core->error->add($e->getMessage());
-		}
-	}
-	# Activate plugin
-	elseif ($plugin_id && !empty($_POST['activate']))
-	{
-		try
-		{
-			$p = $core->plugins->getDisabledModules();
-			if (!isset($p[$plugin_id])) {
-				throw new Exception(__('No such plugin.'));
-			}
-
-			# --BEHAVIOR-- pluginBeforeActivate
-			$core->callBehavior('pluginsBeforeActivate', $plugin_id);
-			
-			$core->plugins->activateModule($plugin_id);
-
-			# --BEHAVIOR-- pluginAfterActivate
-			$core->callBehavior('pluginsAfterActivate', $plugin_id);
-			
-			http::redirect('plugins.php');
-		}
-		catch (Exception $e)
-		{
-			$core->error->add($e->getMessage());
-		}
-	}
-	# Plugin upload
-	elseif ((!empty($_POST['upload_pkg']) && !empty($_FILES['pkg_file'])) ||
-		(!empty($_POST['fetch_pkg']) && !empty($_POST['pkg_url'])))
-	{
-		try
-		{
-			if (empty($_POST['your_pwd']) || !$core->auth->checkPassword(crypt::hmac(DC_MASTER_KEY,$_POST['your_pwd']))) {
-				throw new Exception(__('Password verification failed'));
-			}
-			
-			if (!empty($_POST['upload_pkg']))
-			{
-				files::uploadStatus($_FILES['pkg_file']);
-				
-				$dest = $p_path.'/'.$_FILES['pkg_file']['name'];
-				if (!move_uploaded_file($_FILES['pkg_file']['tmp_name'],$dest)) {
-					throw new Exception(__('Unable to move uploaded file.'));
-				}
-			}
-			else
-			{
-				$url = urldecode($_POST['pkg_url']);
-				$dest = $p_path.'/'.basename($url);
-				
-				try
-				{
-					$client = netHttp::initClient($url,$path);
-					$client->setUserAgent('Dotclear - http://www.dotclear.org/');
-					$client->useGzip(false);
-					$client->setPersistReferers(false);
-					$client->setOutput($dest);
-					$client->get($path);
-				}
-				catch( Exception $e)
-				{
-					throw new Exception(__('An error occurred while downloading the file.'));
-				}
-				
-				unset($client);
-			}
-
-			# --BEHAVIOR-- pluginBeforeAdd
-			$core->callBehavior('pluginsBeforeAdd', $plugin_id);
-						
-			$ret_code = $core->plugins->installPackage($dest,$core->plugins);
-
-			# --BEHAVIOR-- pluginAfterAdd
-			$core->callBehavior('pluginsAfterAdd', $plugin_id);
-			if ($ret_code == 2) {
-				dcPage::addSuccessNotice(__('Plugin has been successfully upgraded'));
-			} else {
-				dcPage::addSuccessNotice(__('Plugin has been successfully installed.'));
-			}
-			http::redirect('plugins.php');
-		}
-		catch (Exception $e)
-		{
-			$core->error->add($e->getMessage());
-			$default_tab = 'addplugin';
-		}
-	}
-}
-
-# Plugin install
-$plugins_install = $core->plugins->installModules();
-
-/* DISPLAY Main page
--------------------------------------------------------- */
+dcPage::check('admin');
+
+# -- "First time" settings setup --
+if ($core->blog->settings->system->plugins_allow_multi_install === null) {
+	$core->blog->settings->system->put(
+		'plugins_allow_multi_install', false, 'boolean', 'Allow multi-installation for plugins', true, true
+	);
+}
+if ($core->blog->settings->system->store_plugin_url === null) {
+	$core->blog->settings->system->put(
+		'store_plugin_url', 'http://update.dotaddict.org/dc2/plugins.xml', 'string', 'Plugins XML feed location', true, true
+	);
+}
+
+# -- Page helper --
+$list = new adminModulesList(
+	$core->plugins, 
+	DC_PLUGINS_ROOT, 
+	$core->blog->settings->system->store_plugin_url
+);
+
+$list::$allow_multi_install = $core->blog->settings->system->plugins_allow_multi_install;
+$list::$distributed_modules = array(
+	'aboutConfig',
+	'akismet',
+	'antispam',
+	'attachments',
+	'blogroll',
+	'blowupConfig',
+	'daInstaller',
+	'fairTrackbacks',
+	'importExport',
+	'maintenance',
+	'pages',
+	'pings',
+	'simpleMenu',
+	'tags',
+	'themeEditor',
+	'userPref',
+	'widgets'
+);
+
+# -- Display module configuration page --
+if ($list->setConfiguration()) {
+
+	# Get content before page headers
+	include $list->includeConfiguration();
+
+	# Gather content
+	$list->getConfiguration();
+
+	# Display page
+	dcPage::open(__('Plugins management'),
+
+		# --BEHAVIOR-- pluginsToolsHeaders
+		$core->callBehavior('pluginsToolsHeaders', $core, true),
+
+		dcPage::breadcrumb(
+			array(
+				html::escapeHTML($core->blog->name) => '',
+				__('Plugins management') => $list->getURL('',false),
+				'<span class="page-title">'.__('Plugin configuration').'</span>' => ''
+			))
+	);
+
+	# Display previously gathered content
+	$list->displayConfiguration();
+
+	dcPage::close();
+
+	# Stop reading code here
+	return;
+}
+
+# -- Execute actions --
+try {
+	$list->doActions('plugins');
+}
+catch (Exception $e) {
+	$core->error->add($e->getMessage());
+}
+
+# -- Plugin install --
+$plugins_install = null;
+if (!$core->error->flag()) {
+	$plugins_install = $core->plugins->installModules();
+}
+
+# -- Page header --
 dcPage::open(__('Plugins management'),
 	dcPage::jsLoad('js/_plugins.js').
-	dcPage::jsPageTabs($default_tab),
+	dcPage::jsPageTabs().
+
+	# --BEHAVIOR-- pluginsToolsHeaders
+	$core->callBehavior('pluginsToolsHeaders', $core, false),
+
 	dcPage::breadcrumb(
 		array(
@@ -204,196 +116,161 @@
 );
 
-if (!empty($_GET['removed'])) {
-	dcPage::success(__('Plugin has been successfully deleted.'));
-}
-if (!empty($_GET['added'])) {
-	dcPage::success(($_GET['added'] == 2 ? __('Plugin has been successfully upgraded') : __('Plugin has been successfully installed.')));
-}
-
-# Plugins install messages
-if (!empty($plugins_install['success']))
-{
-	echo '<div class="static-msg">'.__('Following plugins have been installed:').'<ul>';
+# -- Plugins install messages --
+if (!empty($plugins_install['success'])) {
+	echo 
+	'<div class="static-msg">'.__('Following plugins have been installed:').'<ul>';
+
 	foreach ($plugins_install['success'] as $k => $v) {
-		echo '<li>'.$k.'</li>';
-	}
-	echo '</ul></div>';
-}
-if (!empty($plugins_install['failure']))
-{
-	echo '<div class="error">'.__('Following plugins have not been installed:').'<ul>';
+		echo 
+		'<li>'.$k.'</li>';
+	}
+
+	echo 
+	'</ul></div>';
+}
+if (!empty($plugins_install['failure'])) {
+	echo 
+	'<div class="error">'.__('Following plugins have not been installed:').'<ul>';
+
 	foreach ($plugins_install['failure'] as $k => $v) {
-		echo '<li>'.$k.' ('.$v.')</li>';
-	}
-	echo '</ul></div>';
-}
-
-# List all active plugins
-echo '<p>'.__('Plugins add new functionalities to Dotclear. '.
-'Here you can activate or deactivate installed plugins.').'</p>';
-
-echo (!$core->plugins->moduleExists('daInstaller') ?
-	sprintf('<p><strong>'.__('You can find additional plugins for your blog on %s.').'</strong></p>',
-		'<a href="http://plugins.dotaddict.org/dc2/">Dotaddict</a>') :
-	sprintf('<p><strong>'.__('You can find additional plugins for your blog on %s or using the %s.').'</strong></p>',
-		'<a href="http://plugins.dotaddict.org/dc2/">Dotaddict</a>',
-		'<a href="plugin.php?p=daInstaller">'.__('DotAddict.org Installer').'</a>'));
-
-if ($is_writable) {
-	echo '<p>'.__('To install or upgrade a plugin you generally just need to upload it '.
-	'in "Install or upgrade a plugin" section.');
-} else {
-	echo '<p>'.__('To install or upgrade a plugin you just need to extract it in your plugins directory.');
-}
-echo '</p>';
+		echo 
+		'<li>'.$k.' ('.$v.')</li>';
+	}
+
+	echo 
+	'</ul></div>';
+}
+
+# -- Display modules lists --
+if ($core->auth->isSuperAdmin() && $list->isWritablePath()) {
+
+	# Updated modules from repo
+	$modules = $list->store->get(true);
+	if (!empty($modules)) {
+		echo 
+		'<div class="multi-part" id="update" title="'.html::escapeHTML(__('Update plugins')).'">'.
+		'<h3>'.html::escapeHTML(__('Update plugins')).'</h3>'.
+		'<p>'.sprintf(
+			__('There is one plugin to update available from repository.', 'There are %s plugins to update available from repository.', count($modules)),
+			count($modules)
+		).'</p>';
+
+		$list
+			->setList('plugin-update')
+			->setTab('update')
+			->setModules($modules)
+			->displayModules(
+				/*cols */		array('icon', 'name', 'version', 'current_version', 'desc'),
+				/* actions */	array('update')
+			);
+
+		echo
+		'<p class="info vertical-separator">'.sprintf(
+			__("Visit %s repository, the resources center for Dotclear."),
+			'<a href="http://dotaddict.org/dc2/plugins">Dotaddict</a>'
+			).
+		'</p>'.
+
+		'</div>';
+	}
+}
 
 echo
-'<div class="multi-part" id="plugins" title="'.__('Plugins').'">';
-
-$p_available = $core->plugins->getModules();
-uasort($p_available,create_function('$a,$b','return strcasecmp($a["name"],$b["name"]);'));
-if (!empty($p_available)) 
-{
+'<div class="multi-part" id="plugins" title="'.__('Installed plugins').'">';
+
+# Activated modules
+$modules = $list->modules->getModules();
+if (!empty($modules)) {
+	
+	echo 
+	'<h3>'.($core->auth->isSuperAdmin() ?__('Activated plugins') : __('Installed plugins')).'</h3>'.
+	'<p>'.__('You can configure and manage installed plugins from this list.').'</p>';
+
+	$list
+		->setList('plugin-activate')
+		->setTab('plugins')
+		->setModules($modules)
+		->displayModules(
+			/* cols */		array('expander', 'icon', 'name', 'config', 'version', 'desc', 'distrib'),
+			/* actions */	array('deactivate', 'delete', 'behavior')
+		);
+}
+
+# Deactivated modules
+if ($core->auth->isSuperAdmin()) {
+	$modules = $list->modules->getDisabledModules();
+	if (!empty($modules)) {
+		echo
+		'<h3>'.__('Deactivated plugins').'</h3>'.
+		'<p>'.__('Deactivated plugins are installed but not usable. You can activate them from here.').'</p>';
+
+		$list
+			->setList('plugin-deactivate')
+			->setTab('plugins')
+			->setModules($modules)
+			->displayModules(
+				/* cols */		array('icon', 'name', 'distrib'),
+				/* actions */	array('activate', 'delete')
+			);
+	}
+}
+
+echo 
+'</div>';
+
+if ($core->auth->isSuperAdmin() && $list->isWritablePath()) {
+
+	# New modules from repo
+	$search = $list->getSearch();
+	$modules = $search ? $list->store->search($search) : $list->store->get();
+
+	if (!empty($search) || !empty($modules)) {
+		echo
+		'<div class="multi-part" id="new" title="'.__('Add plugins').'">'.
+		'<h3>'.__('Add plugins from repository').'</h3>'.
+		'<p>'.__('Search and install plugins directly from repository.').'</p>';
+
+		$list
+			->setList('plugin-new')
+			->setTab('new')
+			->setModules($modules)
+			->displaySearch()
+			->displayIndex()
+			->displayModules(
+				/* cols */		array('expander', 'name', 'score', 'version', 'desc'),
+				/* actions */	array('install'),
+				/* nav limit */	true
+			);
+
+		echo
+		'<p class="info vertical-separator">'.sprintf(
+			__("Visit %s repository, the resources center for Dotclear."),
+			'<a href="http://dotaddict.org/dc2/plugins">Dotaddict</a>'
+			).
+		'</p>'.
+
+		'</div>';
+	}
+
+	# Add a new plugin
 	echo
-	'<h3>'.__('Activated plugins').'</h3>'.
-	'<div class="table-outer clear">'.
-	'<table class="plugins"><tr>'.
-	'<th>'.__('Plugin').'</th>'.
-	'<th class="nowrap">'.__('Version').'</th>'.
-	'<th class="nowrap">'.__('Details').'</th>'.
-	'<th class="nowrap">'.__('Action').'</th>'.
-	'</tr>';
-	
-	$distrib_plugins = array('aboutConfig','akismet','antispam','attachments','blogroll','blowupConfig','daInstaller',
-		'fairTrackbacks','importExport','maintenance','pages','pings','simpleMenu','tags','themeEditor','userPref','widgets');
-	$distrib_img = '<img src="images/dotclear_pw.png"'.
-		' alt="'.__('Plugin from official distribution').'" title="'.__('Plugin from official distribution').'" />';
-
-	foreach ($p_available as $k => $v)
-	{
-		$is_deletable = $is_writable && preg_match('!^'.$p_path_pat.'!',$v['root']);
-		$is_deactivable = $v['root_writable'];
-		$is_distrib = in_array($k, $distrib_plugins);
-		
-		echo
-		'<tr class="line wide">'.
-		'<td class="minimal nowrap"><strong>'.html::escapeHTML($k).'</strong></td>'.
-		'<td class="minimal">'.html::escapeHTML($v['version']).'</td>'.
-		'<td class="maximal'.($is_distrib ? ' distrib' : '').'"><strong>'.html::escapeHTML(__($v['name'])).'</strong> '.
-		'<br />'.html::escapeHTML(__($v['desc'])).($is_distrib ? ' '.$distrib_img : '').'</td>'.
-		'<td class="nowrap action">';
-		
-		if ($is_deletable || $is_deactivable)
-		{
-			echo
-			'<form action="plugins.php" method="post">'.
-			'<div>'.
-			$core->formNonce().
-			form::hidden(array('plugin_id'),html::escapeHTML($k)).
-			($is_deactivable ? '<input type="submit" name="deactivate" value="'.__('Deactivate').'" /> ' : '').
-			($is_deletable ? '<input type="submit" class="delete" name="delete" value="'.__('Delete').'" /> ' : '').
-			'</div>'.
-			'</form>';
-		}
-		
-		echo
-		'</td>'.
-		'</tr>';
-	}
+	'<div class="multi-part" id="addplugin" title="'.__('Install or upgrade manually').'">'.
+	'<h3>'.__('Add plugins from a package').'</h3>'.
+	'<p>'.__('You can install plugins by uploading or downloading zip files.').'</p>';
+
+	$list->displayManualForm();
+
 	echo
-	'</table></div>';
-}
-
-$p_disabled = $core->plugins->getDisabledModules();
-uksort($p_disabled,create_function('$a,$b','return strcasecmp($a,$b);'));
-if (!empty($p_disabled))
-{
-	echo
-	'<h3>'.__('Deactivated plugins').'</h3>'.
-	'<div class="clear table-outer">'.
-	'<table class="plugins"><tr>'.
-	'<th>'.__('Plugin').'</th>'.
-	'<th class="nowrap">'.__('Action').'</th>'.
-	'</tr>';
-	
-	foreach ($p_disabled as $k => $v)
-	{
-		$is_deletable = $is_writable && preg_match('!^'.$p_path_pat.'!',$v['root']);
-		$is_activable = $v['root_writable'];
-		
-		echo
-		'<tr class="line wide">'.
-		'<td class="maximal nowrap"><strong>'.html::escapeHTML($k).'</strong></td>'.
-		'<td class="nowrap action">';
-		
-		if ($is_deletable || $is_activable)
-		{
-			echo
-			'<form action="plugins.php" method="post">'.
-			'<div>'.
-			$core->formNonce().
-			form::hidden(array('plugin_id'),html::escapeHTML($k)).
-			form::hidden(array('deactivated'),1).
-			($is_activable ? '<input type="submit" name="activate" value="'.__('Activate').'" /> ' : '').
-			($is_deletable ? '<input type="submit" class="delete" name="delete" value="'.__('Delete').'" /> ' : '').
-			'</div>'.
-			'</form>';
-		}
-		
-		echo
-		'</td>'.
-		'</tr>';
-	}
-	echo
-	'</table></div>';
-}
-
-echo '</div>';
-
-# Add a new plugin
-echo
-'<div class="multi-part" id="addplugin" title="'.__('Install or upgrade a plugin').'">';
-
-if ($is_writable)
-{
-	echo '<p>'.__('You can install plugins by uploading or downloading zip files.').'</p>';
-	
-	# 'Upload plugin' form
-	echo
-	'<form method="post" action="plugins.php" id="uploadpkg" enctype="multipart/form-data" class="fieldset">'.
-	'<h3>'.__('Upload a zip file').'</h3>'.
-	'<p class="field"><label for="pkg_file" class="classic required"><abbr title="'.__('Required field').'">*</abbr> '.__('Plugin zip file:').'</label> '.
-	'<input type="file" id="pkg_file" name="pkg_file" /></p>'.
-	'<p class="field"><label for="your_pwd1" class="classic required"><abbr title="'.__('Required field').'">*</abbr> '.__('Your password:').'</label> '.
-	form::password(array('your_pwd','your_pwd1'),20,255).'</p>'.
-	'<p><input type="submit" name="upload_pkg" value="'.__('Upload plugin').'" />'.
-	$core->formNonce().
-	'</p>'.
-	'</form>';
-	
-	# 'Fetch plugin' form
-	echo
-	'<form method="post" action="plugins.php" id="fetchpkg" class="fieldset">'.
-	'<h3>'.__('Download a zip file').'</h3>'.
-	'<p class="field"><label for="pkg_url" class="classic required"><abbr title="'.__('Required field').'">*</abbr> '.__('Plugin zip file URL:').'</label> '.
-	form::field(array('pkg_url','pkg_url'),40,255).'</p>'.
-	'<p class="field"><label for="your_pwd2" class="classic required"><abbr title="'.__('Required field').'">*</abbr> '.__('Your password:').'</label> '.
-	form::password(array('your_pwd','your_pwd2'),20,255).'</p>'.
-	'<p><input type="submit" name="fetch_pkg" value="'.__('Download plugin').'" />'.
-	$core->formNonce().'</p>'.
-	'</form>';
-}
-else
-{
-	echo
-	'<p class="static-msg">'.
-	__('To enable this function, please give write access to your plugins directory.').
-	'</p>';
-}
-echo '</div>';
+	'</div>';
+}
 
 # --BEHAVIOR-- pluginsToolsTabs
-$core->callBehavior('pluginsToolsTabs',$core);
+$core->callBehavior('pluginsToolsTabs', $core);
+
+# -- Notice for super admin --
+if ($core->auth->isSuperAdmin() && !$list->isWritablePath()) {
+	echo 
+	'<p class="warning">'.__('Some functions are disabled, please give write access to your plugins directory to enable them.').'</p>';
+}
 
 dcPage::close();
-?>
